#set -x
file=/tmp/$$

if [ -L /config/dropbear ] ; then
    rm -r /config/dropbear
fi

[ ! -d "/tmp/mnt" ] && mkdir /tmp/mnt

get_xilinx() {
  md5=$( head /tmp/mnt/update.image.gz | md5sum | awk {'print $1'} )
  if [ "$md5" = "b11b989fa7bafb1b9e2004280e6d6dd6" ]; then
    xilinx="19"
  elif [ "$md5" = "fdf945bc5aabd56e798388809254bc73" ]; then
    xilinx="17"
  else
    xilinx="NA"
    echo "Unknown series" >> /tmp/upgrade_result
  fi
}

update_sd() {
  if [ "$xilinx" = "19" ]; then
    cp -rf 19_uramdisk.image.gz /tmp/mnt/uramdisk.image.gz
    cp -rf 19_update.image.gz  /tmp/mnt/update.image.gz
  elif [ "$xilinx" = "17" ]; then
    chmod +x hpatchz
    ./hpatchz 19_uramdisk.image.gz 19-17_patch_uramdisk.image.gz /tmp/mnt/17_uramdisk.image.gz > /dev/null 2>&1
    res=$?
    if [ $res -eq 0 ]; then
      mv /tmp/mnt/17_uramdisk.image.gz /tmp/mnt/uramdisk.image.gz
      cp -rf 17_update.image.gz  /tmp/mnt/update.image.gz
    else
      echo "Patch filed!!!"
    fi
  fi
}

if [ -e /dev/mmcblk0p1 ]; then
    mount -t vfat /dev/mmcblk0p1 /tmp/mnt
    get_xilinx
    update_sd
    umount /dev/mmcblk0p1
    sync
elif [ -e /dev/mmcblk0 ]; then
    mount -t vfat /dev/mmcblk0 /tmp/mnt
    get_xilinx
    update_sd
    umount /dev/mmcblk0
    sync
else
    echo "Error SD card!" >> /tmp/upgrade_result
fi

rm -rf /config/scanfreqdone 2>/dev/null

sync >/dev/null 2>&1
